//
//  OpticonDataEvent.hpp
//  opn_driver
//
//  Created by Nima Nourozi on 11/25/15.
//  Copyright (c) 2015 Nima Nourozi. All rights reserved.
//

#ifndef opn_driver_OpticonDataEvent_hpp
#define opn_driver_OpticonDataEvent_hpp

#include "Event.hpp"
#include <string>
#include "Barcode.hpp"

/* The classes below are exported */
#pragma GCC visibility push(default)
class OpticonDataEvent : public Event
{
public:
    OpticonDataEvent(std::string const & msg, UInt32 count, std::vector<Barcode> data, UInt32 handler) :
    msg(msg),
    count(count),
    data(data),
    handler(handler)
    {
    }
    
    virtual ~OpticonDataEvent() { }
    
    /*
     * Return the event message
     */
    std::string const & getMessage() {
        return msg;
    }
    
    /* 
     * Return number of barcodes available
     */
    UInt32 const & getCount() {
        return count;
    }
    
    /*
     * Return the data
     */
    const std::vector<Barcode> & getData() {
        return data;
    }
    
    /*
     * Return the USB handler the data belongs to
     */
    UInt32 const & getHandler() {
        return handler;
    }
    
private:
    std::string const & msg;
    UInt32 count;
    std::vector<Barcode> data;
    UInt32 handler;
};
#pragma GCC visibility pop
#endif
